#ifndef _lcthw_queue_h
#define _lcthw_queue_h
#include <lcthw/list.h>

typedef List Queue;
typedef ListNode QueueNode;

static inline Queue *Queue_create()
{
	return (Queue *) List_create();
}

static inline void Queue_destroy(Queue *queue)
{
	List_destroy((List *)queue);
}

static inline void Queue_send(Queue *queue, void *value)
{
	List_push((List *)queue, value);
}

static inline void *Queue_recv(Queue *queue)
{
	return List_shift((List *)queue);
}

static inline void *Queue_peek(Queue *queue)
{
	return List_first((List *)queue);
}

static inline int Queue_count(Queue *queue)
{
	return List_count((Queue *)queue);
}

#define QUEUE_FOREACH(Q,C) ListNode *_node = NULL; \
	ListNode *C = NULL;\
	for(C = _node = Q->first; _node != NULL; C = _node = _node->next)

#endif
